pro zad14_1, data, h_prwsz=h_prwsz, h_osttn=h_osttn, maplimit=maplimit, paleta=paleta

  ; obsuga argumentw nazwanych i ustawienia domylne
  if strlen(data) ne 10 then message, "podaj argument, np.: GDL> zad14_1, '2009011906'"
  if not keyword_set(h_prwsz)  then h_prwsz = 0
  if not keyword_set(h_osttn)  then h_osttn = 48
  if not keyword_set(maplimit) then maplimit = [45, 0, 63, 36]; lat_min, lon_min, lat_max, lon_max
  loadct, keyword_set(paleta) ? paleta : 4
  
  ; kolejno wiedomoci w pliku GRIB i poziomy izolinii
  i_geop = 0 & i_velu = 1 & i_velv = 2 & i_vort = 3
  lev_vort = -0.0002 + findgen(11) * 0.0001
  lev_geop =   4800 + findgen(21) * 50

  ; ptla po godzinach prognozy
  h_perstp = 3
  for h = h_prwsz, h_osttn, h_perstp do begin 
    hh_str = string(h, f='(I2.2)')

    ; pobranie plikw z serwera www NOAA
    plik = "gfs_" + data + "_" + hh_str + ".grib"
    cmd = "wget --quiet --continue --output-document=" + plik $
      + " 'http://nomads.ncep.noaa.gov/cgi-bin/filter_gfs_hd.pl?file=gfs.t06z.mastergrb2f" + hh_str $
      + "&lev_500_mb=on&var_HGT=on&var_UGRD=on&var_VGRD=on&var_ABSV=on&subregion=&dir=%2Fgfs." + data + "%2Fmaster" $
      + "&bottomlat=" + strtrim(string(maplimit[0]), 2) + "&leftlon=" + strtrim(string(maplimit[1]), 2) + "&" $
      + "&toplat=" + strtrim(string(maplimit[2]), 2) + "&rightlon=" + strtrim(string(maplimit[3]), 2) + "'"
    spawn, cmd, output, exit_status=status
    if status ne 0 then begin
      message, /continue, 'aqq'
      continue
    endif
  
    ; pobranie danych z plikw GRIB (w pierwszym kroku pobranie wsp. i alokacja pamici)
    grib_f = grib_open_file(plik)
    n_msgs = grib_count_in_file(grib_f)
    for m = 0, n_msgs - 1 do begin
      grib_m = grib_new_from_file(grib_f)
      if h eq h_prwsz and m eq 0 then begin
        grib_get_data, grib_m, lats, lons, tmp
        grib_get, grib_m, 'numberOfPointsAlongAParallel', n_lons
        grib_get, grib_m, 'numberOfPointsAlongAMeridian', n_lats
        n_stps = 1 + (h_osttn - h_prwsz) / h_perstp
        lons = (temporary(lons))[indgen(n_lons)]
        lats = (temporary(lats))[indgen(n_lats) * n_lons]
        vals = fltarr(n_lons, n_lats, n_stps, n_msgs, /nozero)
      endif else grib_get, grib_m, 'values', tmp
      vals[*, *, h/h_perstp, m] = temporary(tmp)
      grib_release, grib_m
    endfor ; m
    grib_close_file, grib_f

    ; zapis mapy konturowej (poszczeglnych klatek animacji)
    set_plot, 'svg'
    device, file=strmid(plik, 0, strlen(plik) - 5) + '.svg'
    map_set, mean(lats), mean(lons), limit=[lats[0], lons[0], lats[n_lats - 1], lons[n_lons - 1]], $
      title="MPDM2008 Zad 14.1 : Prognoza GFS " + data + "+" + hh_str, /gnomic, /noborder
    contour, vals[*, *, h/h_perstp, i_vort], lons, lats, /over, /fill, lev=lev_vort
    map_continents, /countries, /coasts, mlinethick=3
    contour, vals[*, *, h/h_perstp, i_geop], lons, lats, /over, /foll, lev=lev_geop, $
      thick=6, c_char=1.3, color=!P.BACKGROUND
    velovect, vals[*, *, h/h_perstp, i_velu], vals[*, *, h/h_perstp, i_velv], lons, lats, /overplot
    device, /close

    ; SVG -> PNG (ImageMAgick nie radzi sobie z tekstem w SVG :( )
    spawn, 'rsvg ' + strmid(plik, 0, strlen(plik) - 5) + '.svg ' + strmid(plik, 0, strlen(plik) - 5) + '.png' 
  endfor ; h

  ; stworzenie (kiepskiej) animacji GIF..., czekamy na animacje w SVG!
  spawn, 'convert -delay 50 gfs_' + data + '*.png gfs_' + data + '.gif'

end
